Page MenuHomePhabricator

DWZ 02/07: Match also DW_TAG_partial_unit when DW_TAG_compile_unit is matched
ClosedPublic

Authored by jankratochvil on Nov 26 2017, 5:10 AM.

Details

Summary

Code commonly checks if the parent DIE is DW_TAG_compile_unit. But DW_TAG_partial_unit also acts as DW_TAG_compile_unit for DWZ as DWZ is using DW_TAG_imported_unit only at the top unit level.

All DWZ patches are also applied in: git clone -b dwz git://git.jankratochvil.net/lldb

Diff Detail

Repository
rL LLVM

Event Timeline

jankratochvil created this revision.Nov 26 2017, 5:10 AM
clayborg requested changes to this revision.Nov 27 2017, 10:27 AM

Seems like it would be cleaner to leave DWARFDebugInfoEntry and DWARFDie alone and just make clients deal with accepting DW_TAG_partial_unit when and where they need to. I don't like the idea of not telling the truth.

This revision now requires changes to proceed.Nov 27 2017, 10:27 AM

Seems like it would be cleaner to leave DWARFDebugInfoEntry and DWARFDie alone and just make clients deal with accepting DW_TAG_partial_unit when and where they need to. I don't like the idea of not telling the truth.

done

jankratochvil retitled this revision from DWZ 06/12: Mask DW_TAG_partial_unit as DW_TAG_compile_unit for Tag() to DWZ 04/11: Match also DW_TAG_partial_unit when DW_TAG_compile_unit is matched.
jankratochvil retitled this revision from DWZ 04/11: Match also DW_TAG_partial_unit when DW_TAG_compile_unit is matched to DWZ 05/11: Match also DW_TAG_partial_unit when DW_TAG_compile_unit is matched.
jankratochvil planned changes to this revision.Apr 14 2018, 4:21 AM
jankratochvil retitled this revision from DWZ 05/11: Match also DW_TAG_partial_unit when DW_TAG_compile_unit is matched to DWZ 02/07: Match also DW_TAG_partial_unit when DW_TAG_compile_unit is matched.

It is now reworked without FileOffset and the remapping to unique DIE offsets for each DW_TAG_partial_unit inclusion by DW_TAG_imported_unit, as discussed in: https://lists.llvm.org/pipermail/lldb-commits/Week-of-Mon-20180409/040324.html

labath edited reviewers, added: aprantl, JDevlieghere; removed: labath.Apr 30 2018, 6:36 AM

Adding some debug info people, as I don't feel qualified to review this.

clayborg accepted this revision.Apr 30 2018, 8:14 AM
This revision is now accepted and ready to land.Apr 30 2018, 8:14 AM
This revision was automatically updated to reflect the committed changes.